package recovery

import (
	"github.com/gin-gonic/gin"
	"github.com/perfect-panel/server/internal/logic/public/recovery"
	"github.com/perfect-panel/server/internal/svc"
	"github.com/perfect-panel/server/internal/types"
	"github.com/perfect-panel/server/pkg/result"
)

func RecoverOrderHandler(svcCtx *svc.ServiceContext) func(c *gin.Context) {
	return func(c *gin.Context) {
		var req types.RecoverOrderRequest
		_ = c.ShouldBind(&req)
		validateErr := svcCtx.Validate(&req)
		if validateErr != nil {
			result.ParamErrorResult(c, validateErr)
			return
		}

		l := recovery.NewRecoverOrderLogic(c.Request.Context(), svcCtx)
		resp, err := l.RecoverOrder(&req)
		result.HttpResult(c, resp, err)
	}
}
